package com.ruoyi.demo.entity.vo;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.datatype.jsr310.deser.LocalDateTimeDeserializer;
import com.fasterxml.jackson.datatype.jsr310.ser.LocalDateTimeSerializer;
import com.ruoyi.demo.entity.Plan;
import lombok.Data;

import java.time.LocalDateTime;

@Data
public class PlanListVo {
    private String planId;
    private String commercialId;
    private String commercialName;
    private String appkey;
    private String appName;
    private String goodsId;
    private String goodsImg;
    private String goodsName;
    private Float goodsPrice;
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @JsonSerialize(using = LocalDateTimeSerializer.class)
    @JsonDeserialize(using = LocalDateTimeDeserializer.class)
    private LocalDateTime planCreateTime;
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @JsonSerialize(using = LocalDateTimeSerializer.class)
    @JsonDeserialize(using = LocalDateTimeDeserializer.class)
    private LocalDateTime planStartTime;
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @JsonSerialize(using = LocalDateTimeSerializer.class)
    @JsonDeserialize(using = LocalDateTimeDeserializer.class)
    private LocalDateTime planEndTime;
    private String state;

    public PlanListVo(Plan plan){
        this.planId = plan.getPlanId();
        this.commercialId = plan.getCommercialId();
        this.commercialName = plan.getCommercialName();
        this.appkey = plan.getAppkey();
        this.appName = plan.getAppName();
        this.goodsId = plan.getGoodsId();
        this.goodsImg = plan.getGoodsImg();
        this.goodsName = plan.getGoodsName();
        this.goodsPrice = plan.getGoodsPrice();
        this.planCreateTime = plan.getPlanCreateTime();
        this.planStartTime = plan.getPlanStartTime();
        this.planEndTime = plan.getPlanEndTime();
        if (plan.getState() == 0)
            this.state = "未审核";
        else if (plan.getState() == 1)
            this.state = "审核通过";
        else
            this.state = "审核未通过";
    }
}
